"use strict";

var tsconfig    = require( "gulp-tsconfig-files" );
var gulp        = require( "gulp"                );
gulp            = require( "gulp-help" )( gulp  );

var tsConfig    = require( "../tsconfig.json" );
var tsFilesGlob = ( function ( c )
{
    return c.filesGlob || c.files || "**/*.ts";
} )( tsConfig );

gulp.task( "tsconfig_files", "Update files section in tsconfig.json", function () {
    gulp.src( tsFilesGlob ).pipe( tsconfig( { newline_eof: true } ) );
} );
