"use strict";

var uglify       = require( "gulp-uglify"       );
var concat       = require( "gulp-concat"       );
var gulp         = require( "gulp"              );
gulp             = require( "gulp-help" )( gulp );

gulp.task( "uglify", "Creates a minified version of the ES5/UMD bundle",  function()
{
    gulp.src( "dist/bundle.js" )
    .pipe( uglify() )
    .pipe( concat( "bundle.min.js" ) )
    .pipe( gulp.dest( "dist" ) );
} );
