/* tslint:disable:max-classes-per-file */
/* tslint:disable:variable-name */
/* tslint:disable:no-trailing-whitespace */
/* tslint:disable:no-consecutive-blank-lines */
/* tslint:disable:no-namespace */
/* tslint:disable:member-access */
/* tslint:disable:typedef-whitespace */
/* tslint:disable:no-internal-module */

declare module EVA.WMS {
  
  export enum AttributeTypes {
    Partner = 0,
    VendorItemNumber = 1,
    ProductType = 2,
    SourceID = 3,
    MaximumHoldingTemprature = 4,
    MinimumHoldingTemprature = 5,
    EstimatedRestockDays = 6,
    IgnoreProduct = 7,
    MinimalDaysOfStock = 8,
    TransferLotFromExternalDays = 9,
    RequiresInboundInspection = 10,
    IsFragile = 11,
    IsUniqueProduct = 12,
    PrintPriceSticker = 13,
    PrintProductSticker = 14,
    FinishCode = 15,
    MaterialCode = 16,
    SeasonCode = 17,
    UpdateLevel = 18,
    ForceSinglePick = 19,
    RecommendedRetailPriceInTax = 20,
    SalesPriceInTax = 21,
  }
  
  export enum InspectionTypes {
    None = 0,
    Count = 1,
    Serial = 2,
    Detail = 3,
  }
  
  export enum ProcessingStatus {
    P = 0,
    E = 1,
    W = 2,
  }
  
  export enum PurchaseOrderTypes {
    Purchase = 0,
  }
  
  export enum RelationTypes {
    Customer = 0,
    Supplier = 1,
    Carrier = 2,
    Undefined = 4,
  }
  
  export enum SalesOrderLineStatusResponse {
    PendingPayment = 0,
    BackOrder = 1,
    New = 2,
    InProcess = 3,
    Completed = 4,
    Cancelled = 5,
    Destroyed = 6,
    Unknown = 7,
  }
  
  export enum SalesOrderReferenceType {
    Invoice = 0,
    FreeText1 = 1,
    FreeText2 = 2,
    FreeText3 = 3,
    FreeText4 = 4,
    FreeText5 = 5,
    FreeText6 = 6,
    FreeText7 = 7,
    AdditionalOrderNumber = 8,
    OrderFreeText1 = 9,
    OrderFreeText2 = 10,
    OrderFreeText3 = 11,
    ParcelshopNetworkId = 12,
    ParcelshopLocationId = 13,
    ParcelshopPicktimeStart = 14,
    ParcelshopLocationPinCode = 15,
    CustomerSpecificBarcode = 16,
    PreShipmentInformationSent = 17,
  }
  
  export enum SalesOrderTypes {
    S = 0,
  }
  
  export enum TransactionTypesPurchaseOrders {
    OV = 0,
    DO = 1,
    GD = 2,
    POC = 3,
    DD = 4,
    DS = 5,
    DM = 6,
  }
  
  export enum TransactionTypesReturnOrders {
    RR = 0,
  }
  
  export enum TransactionTypesSalesOrders {
    LC = 0,
    RS = 1,
    CS = 2,
    PACK = 3,
    PDV = 4,
    PDC = 5,
    SMC = 6,
    LD = 7,
    LNC = 8,
    PC = 9,
  }
  
  export enum UnitOfMeasureTypes {
    EA = 0,
    BX = 1,
    OMDOOS = 2,
    PL = 3,
  }
  
  export enum WmsPurchaseOrderModes {
    PurchaseOrders = 1,
    Shipments = 2,
  }
  
  export enum WmsSalesOrderCancelModes {
    Cancel = 1,
    Recreate = 2,
  }
  
}