"use strict";

var tslint      = require( "gulp-tslint" );
var gulp        = require( "gulp"        );
gulp            = require( "gulp-help" )( gulp );

var tsConfig    = require( "../tsconfig.json" );
var tsFilesGlob = ( function ( c )
{
    return c.filesGlob || c.files || "**/*.ts";
} )( tsConfig );

gulp.task( "tslint", "Lints all TypeScript source files", function ()
{
    return gulp.src( tsFilesGlob )
    .pipe( tslint( {
        formatter: "prose"
    } ) )
    .pipe( tslint.report() );
} );
