/* tslint:disable:max-classes-per-file */
/* tslint:disable:variable-name */
/* tslint:disable:no-trailing-whitespace */
/* tslint:disable:no-consecutive-blank-lines */
/* tslint:disable:no-namespace */
/* tslint:disable:member-access */
/* tslint:disable:typedef-whitespace */
/* tslint:disable:no-internal-module */

declare module EVA.Payment.Mollie {
  
  export class Amount {
    Minimum : number; // Decimal
    Maximum : number; // Decimal
  }
  
  export class Image {
    Normal : string; 
    Bigger : string; 
  }
  
  export class Issuer {
    ID : string; 
    Name : string; 
    Image : EVA.Payment.Mollie.Image; 
  }
  
  export class ListMollieGateways extends EVA.API.RequestMessageGeneric<EVA.Payment.Mollie.ListMollieGatewaysResponse> {
  }
  
  export class ListMollieGatewaysResponse extends EVA.API.ResponseMessage {
    Gateways : EVA.Payment.Mollie.Method[]; 
  }
  
  export class Method {
    ID : string; 
    Description : string; 
    Amount : EVA.Payment.Mollie.Amount; 
    Image : EVA.Payment.Mollie.Image; 
    Issuers : EVA.Payment.Mollie.Issuer[]; 
  }
  
}